use std::sync::mpsc::{Sender, Receiver};
use std::thread::JoinHandle;

use ::thread_state::ThreadState;

use chrono::MonotonicTime;



///
pub struct ThreadData
{
   ///
   pub state: ThreadState,

   ///
   pub handle: JoinHandle<()>,

   ///
   pub idle_time: MonotonicTime,

   ///
   pub shutdown_sender: Sender<bool>,

   ///
   pub state_receiver: Receiver<ThreadState>,
}



impl ThreadData
{
   pub fn new(join_handle: JoinHandle<()>, shutdown_s: Sender<bool>,
              state_r: Receiver<ThreadState>) -> ThreadData
   {
      ThreadData
      {
         state: ThreadState::Starting,
         handle: join_handle,
         idle_time: MonotonicTime::current(),
         shutdown_sender: shutdown_s,
         state_receiver: state_r
      }
   }
}
