///
#[derive(Clone, Copy)]
pub enum ThreadState
{
   ///
   Starting,

   ///
   Idle,

   ///
   Processing,

   ///
   Finished
}



impl ThreadState
{
   /// Get a str representation of this variant.
   pub fn to_str(&self) -> &'static str
   {
      match *self
      {
         ThreadState::Starting =>
         {
            "Starting"
         }

         ThreadState::Idle =>
         {
            "Idle"
         }

         ThreadState::Processing =>
         {
            "Processing"
         }

         ThreadState::Finished =>
         {
            "Finished"
         }
      }
   }

   /// Get a String representation of this variant.
   pub fn to_string(&self) -> String
   {
      String::from(self.to_str())
   }
}

impl ::std::fmt::Debug for ThreadState
{
   fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result
   {
      write!(f, "{}", self.to_str())
   }
}

impl ::std::fmt::Display for ThreadState
{
   fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result
   {
      write!(f, "{}", self.to_str())
   }
}
